Unit IP01R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure IP01R(var X :Array of Real; var Y :Array of Real;
                N :Integer; var COF :Array of Real;
                var S :Array of Real);

implementation

procedure IP01R(var X :Array of Real; var Y :Array of Real;
                N :Integer; var COF :Array of Real;
                var S :Array of Real);
var
I,J,N1,N1I,K,K1 :Integer;
PHI,FF,B :Real;
const
ZERO :Real = 0.0;
ONE :Real = 1.0;
label
_10,_20,_30,_40,_50,_60;
begin
for I:=1 to N do
 begin
  S[I-1] := ZERO;
  COF[I-1] := ZERO;
_10:
 end;
N1 := N-1;
S[N-1] := -X[0];
for I:=2 to N do
 begin
  N1I := N+1-I;
  for J:=N1I to N1 do
   begin
    S[J-1] := S[J-1]-X[I-1]*S[J+0];
_20:
   end;
  S[N-1] := S[N-1]-X[I-1];
_30:
 end;
for J:=1 to N do
 begin
  PHI := N;
  for K1:=1 to N1 do
   begin
    K := N1+1-K1;
    PHI := K*S[K+0]+X[J-1]*PHI;
_40:
   end;
  FF := Y[J-1]/PHI;
  B := ONE;
  for K1:=1 to N do
   begin
    K := N+1-K1;
    COF[K-1] := COF[K-1]+B*FF;
    B := S[K-1]+X[J-1]*B;
_50:
   end;
_60:
 end;
end;

end.
